event_inherited();
//image_angle = round(direction / 16) * 16;


if (bullet_type != -1)
{
switch (bullet_type)	
	{
	case weapon.star_beam: 
		image_xscale = clamp(image_xscale + time/10,0,3);
		if (image_xscale>=3) {image_yscale = clamp(image_yscale - 0.03 ,0,1)}
		break;
	
	
	case weapon.star_gun: 
		if (instance_number(obj_star_charge) < 6)
			{
			var radius = irandom_range(9,32);
			var muzzle = instance_create_depth(
				x - lengthdir_x(radius,image_angle+((90+irandom_range(-20,20)) *gun_side)),
				y - lengthdir_y(radius,image_angle+((90+irandom_range(-20,20)) *gun_side)),
				depth,obj_star_charge);
			muzzle.image_angle	= image_angle;
			muzzle.direction	= direction;
			muzzle.radius		= radius;
			muzzle.team			= team;
			muzzle.creator		= creator;
			}
		else
			{
			obj_spaceship.arr_ammo_inventory[weapon.star_gun]++;
			}
		instance_destroy();
		break;
				
		
	case weapon.bolter: 
		if (time == 0) 
			{
			var dirty_fix = (gun_side == 1) ? 1 : 0;
			
			x += lengthdir_x(6,image_angle+(90*gun_side));
			y += lengthdir_y(6,image_angle+(90*gun_side));
			x += lengthdir_x(8,image_angle+(180));
			y += lengthdir_y(8,image_angle+(180));
			
			var muzzle = instance_create_depth(
				x - lengthdir_x(1+dirty_fix,image_angle+(90*gun_side)),
				y - lengthdir_y(1+dirty_fix,image_angle+(90*gun_side)),
				depth,obj_bullet_muzzle);
			muzzle.image_angle	= image_angle;
			muzzle.direction	= direction;
			}
		break;	 
		
	case weapon.laser: 
		for (var d=-1; d<2; d++)
			{
			var list_collisions = ds_list_create();
		
			if (collision_line_list(
				x+lengthdir_x(8,image_angle+(90*d)),
				y+lengthdir_y(8,image_angle+(90*d)),
				x+lengthdir_x(8,image_angle+(90*d))+lengthdir_x(32*20,image_angle),
				y+lengthdir_y(8,image_angle+(90*d))+lengthdir_y(32*20,image_angle),
				obj_hp_entity,false,true,list_collisions,false))
			//if (collision_line_list(x,y,x+lengthdir_x(32*20,image_angle),y+lengthdir_y(32*20,image_angle),obj_hp_entity,false,true,list_collisions,false))
				{
				var dmg = damage;
				var dir = image_angle;
				for (var i=0; i<ds_list_size(list_collisions); i++)
					{
					if (list_collisions[| i] == creator) {continue;}
				
					with (list_collisions[| i])
						{
						hp -= dmg;	
						stunned = stun_duration;
						//apply_knockback(dir, 0.5);
						}
					}
				}
				ds_list_destroy(list_collisions);
			}
		break;	
		case weapon.missile: 
			spd = clamp(spd + (time/100000),-10,5)
			speed = spd;
			break;
			
		case weapon.small_missile: 
			spd = clamp(spd + (time/100000),-10,3)
			speed = spd;
			
			if (time>60)
				{
				if (time mod 10 == 0 || target == -1 || !instance_exists(target))
					{
					target = instance_nearest(x,y,obj_hp_entity);
					}
					
				if (target != obj_spaceship && target != -1)
					{
					//direction += min(5, angle_difference(direction, point_direction(x,y,target.x,target.y)));
					
					var new_dir = point_direction(x, y, target.x, target.y);
					var diff = angle_difference(direction, new_dir);
					direction += min(2 * sign(diff)/15, diff/15);
					//move_towards_point(target.x,target.y,speed)
					//direction	= (direction + point_direction(x,y,target.x,target.y))/2;
					image_angle = direction;
					}
				}
			break;
	}
}

if (time > life_time) 
{
	instance_destroy();
	
	if (bullet_type != -1)
		{
		switch (bullet_type)	
			{
			case weapon.bolter: create_explosion(x, y, random_range(0.6, 0.8)); break;
			case weapon.laser:  break;
			case weapon.small_missile: create_explosion(x, y, random_range(0.8, 1.0)); break;
			case weapon.missile:  
				create_explosion(x, y, random_range(0.6, 0.8))
				sfx_play_position(x, y, snd_missile_split, 0.5, random_range(0.9, 1.1), random_range(0.9, 1.1));

				for (var i=-55; i<=55; i+=10;)
					{
					var missile = instance_create_depth(x,y,depth,obj_bullet);
					missile.direction		= image_angle+i;
					missile.image_angle		= image_angle+i;
					missile.sprite_index	= grid_weapons[# weapon.small_missile, bullet_property.sprite];
					missile.bullet_type		= grid_weapons[# weapon.small_missile, bullet_property.type];
					missile.damage			= grid_weapons[# weapon.small_missile, bullet_property.damage] 	
					missile.speed			= grid_weapons[# weapon.small_missile, bullet_property.spd];
					missile.life_time		= grid_weapons[# weapon.small_missile, bullet_property.life_time];
					missile.team			= team;
					missile.creator			= creator;
					}
				break;
			}
		}
	}
time++;
