event_inherited();
always_active = true;
hp = 30000000000000;
detectable = true;
image_angle = round(irandom(360) / 16) * 16;
ping_size = 5;
ping_color = COLORS.lime;
team = TEAMS.player;

sector_type = SECTOR_TYPES.miniboss;

var scale = random_range(0.8, 1);

image_xscale = scale * choose(-1, 1);
image_yscale = scale;

friction = 0.05;

follow_player = false;

detect_on_radar = function(radar_start_angle, radar_end_angle, radar_range, center_x, center_y)
{
	if (!detected && detectable)
	{
		var dist = point_distance(x,y, center_x, center_y);
		var dir = point_direction(center_x, center_y, x, y);
		
		if (dir <= radar_start_angle && dir > radar_end_angle)
		{
			var len = min(radar_range, dist) / radar_range * 150;
			var xx = center_x + lengthdir_x(len, dir);
			var yy = center_y + lengthdir_y(len, dir);
		
			var ping = instance_create_layer(xx, yy, "InstancesTop", obj_ping);
			ping.image_blend = ping_color;
			ping.size = ping_size + 4 / (max(1, dist / 1000));
			ping.image_alpha = 3;
			
			var pitch = 1;
			var gain = 0.5;
			if (dist < 8000)
			{
				var ratio = 1 - (dist / 8000);
				gain += 0.15 * ratio;
				pitch += 2.5 * ratio;
			}
			sfx_play(snd_sonar, 0.9, gain, pitch);
			
			detected = 10;
		}
	}
}
