
event_inherited();
if (engine_sound_delay > 0)
{
	engine_sound_delay -= 1;	
}

var gp_xx = gamepad_axis_value(0, gp_axisrh);
var gp_yy = gamepad_axis_value(0, gp_axisrv);
if (point_distance(0, 0, gp_xx, gp_yy) > 0.35)
{
	use_gamepad = true;
	aim_angle = point_direction(0, 0, gp_xx, gp_yy);
}

if (mouse_check_button_pressed(mb_left))
{
	use_gamepad = false;	
}

if (!use_gamepad)
{
	aim_angle = point_direction(x,y,mouse_x,mouse_y);
}
	


var xx =	sign(	(keyboard_check(vk_right)	+ (keyboard_check(ord("D")))) -
					(keyboard_check(vk_left)	+ (keyboard_check(ord("A")))))
var yy =	sign(	(keyboard_check(vk_down)	+ (keyboard_check(ord("S")))) -
					(keyboard_check(vk_up)		+ (keyboard_check(ord("W")))))
					
var gp_xx = gamepad_axis_value(0,gp_axislh);
var gp_yy = gamepad_axis_value(0,gp_axislv);

if (abs(gp_xx) > 0.35)
{
	xx += gp_xx;	
}

if (abs(gp_yy) > 0.35)
{
	yy += gp_yy;	
}
					
// Set image depending on aim direction and steering direction
var steering_direction = point_direction(0, 0, xx, yy);
var angle_diff = angle_difference(image_angle, steering_direction);
var abs_angle_diff = abs(angle_diff);

if (abs(xx) + abs(yy) <= 0)
{
	// No acceleration, use idle sprite
	sprite_index = sprite_idle;	
}
else
{
	if (engine_sound_delay <= 0)
	{
		var spd = point_distance(0, 0, x_speed, y_speed);
		var pitch_increase = spd / max_speed;
		sfx_play(snd_engines, 0.6, random_range(0.9, 1.1), 0.4 + pitch_increase);
		engine_sound_delay = irandom_range(7,9);
	}
	
	if (abs_angle_diff < 60)
	{
		// Accelerate mostly forward
		sprite_index = sprite_forward;
	}
	else if (abs_angle_diff < 150)
	{
		sprite_index = sprite_strafe;
		image_yscale = -sign(angle_diff);
	}
	else
	{
		// Goink backward
		sprite_index = sprite_backward;
	}
}
	
var v_fric = (xx == 0 && yy == 0) ? fric : 1;

x_speed = clamp((x_speed + xx/steering)*v_fric, -max_speed, max_speed);
y_speed = clamp((y_speed + yy/steering)*v_fric, -max_speed, max_speed);

x += x_speed;
y += y_speed;

if (!instance_exists(obj_spaceship)) {exit;}
if (obj_spaceship.arr_ammo_inventory[current_weapon]<=0) {current_weapon = weapon.bolter;}

if ((gamepad_button_check(0, gp_shoulderr) || gamepad_button_check(0, gp_shoulderrb)  || mouse_check_button(mb_left)) && 
	cooldown <= 0 && current_weapon >= 0 && obj_spaceship.arr_ammo_inventory[current_weapon]>0)
	{
	arr_ammo_inventory[current_weapon]--;
	

	var bullet = instance_create_depth(x,y,depth,obj_bullet);
	bullet.direction	= aim_angle;
	bullet.image_angle	= aim_angle;
	bullet.sprite_index = grid_weapons[# current_weapon, bullet_property.sprite];
	bullet.bullet_type	= grid_weapons[# current_weapon, bullet_property.type];
	bullet.damage		= grid_weapons[# current_weapon, bullet_property.damage] 	
	bullet.speed		= grid_weapons[# current_weapon, bullet_property.spd];
	bullet.life_time	= grid_weapons[# current_weapon, bullet_property.life_time];
	bullet.team			= team;
	bullet.creator		= id;
	bullet.gun_side		= gun_side;
	cooldown			= grid_weapons[# current_weapon, bullet_property.cooldown];
	//show_debug_message(grid_weapons[# current_weapon, bullet_property.type])
	x_speed += lengthdir_x(-grid_weapons[# current_weapon, bullet_property.knockback],image_angle);
	y_speed += lengthdir_y(-grid_weapons[# current_weapon, bullet_property.knockback],image_angle);
	
	var bullet_snd = grid_weapons[# current_weapon, bullet_property.sound];
	var pitch =  random_range(0.9, 1.1)
	
	if (current_weapon == weapon.star_gun)
	{
		pitch = 0.5 + 0.1 * instance_number(obj_star_charge);
	}
	
	sfx_play(grid_weapons[# current_weapon, bullet_property.sound], 0.5, 1, min(2.5, pitch));
	
	gun_side *= -1;
	}


if (cooldown > 0) {cooldown--;}

if (keyboard_check_pressed(ord("1")) || gamepad_button_check(0, gp_padd)) {current_weapon = arr_weapon_inventory[0];}
if (keyboard_check_pressed(ord("2")) || gamepad_button_check(0, gp_padl)) {current_weapon = arr_weapon_inventory[1];}
if (keyboard_check_pressed(ord("3")) || gamepad_button_check(0, gp_padu)) {current_weapon = arr_weapon_inventory[2];}
if (keyboard_check_pressed(ord("4")) || gamepad_button_check(0, gp_padr)) {current_weapon = arr_weapon_inventory[3];}

